class Book
  attr_reader :title, :author

  def initialize(title, author)
    @title = title
    @author = author
  end
end

class BookShelf
  def initialize
    @books = []
  end

  def add(book)
    @books << book
  end

  def search(keyword)
    result = search_by_title_or_author(keyword)
    printout_result(result)
  end

  private
  # 검색 결과 부분을 메소드로 추출
  def printout_result(result)
    return "검색결과는 0건입니다" if result.size == 0

    <<-EOF
#{result.size}건 히트하였습니다
#{result.map{|r| "#{r.title}: #{r.author} 저"}.join("\n")}
    EOF
  end

  def search_by_title_or_author(keyword)
    result = @books.select do |book|
      book.title =~ /#{keyword}/
    end
    result += @books.select do |book|
      book.author =~ /#{keyword}/
    end
  end
end
