package my.petstore.entity;


import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "inventories")
public class Inventory extends BaseEntity {

    @Column(name = "qty")
    private int quantity;

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "item_id")
    private Item item; // XXX could be uni-direction
    

    public int getQuantity() { return quantity; }
    public void setQuantity(int quantity) { this.quantity = quantity; }

    public int decrementQuantity(int n) {
        setQuantity(this.quantity - n);
        return this.quantity;
    }

    public Item getItem() { return item; }
    public void setItem(Item item) { this.item = item; }

    public static final Inventory NULL = new Inventory() {
        {
        }
    };
}
