package my.petstore.entity;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
public class OrderStatus extends BaseEntity {

    private OrderStatus() {}
    public OrderStatus(Date timestamp, String status, OrderData orderData) {
        this.timestamp = timestamp;
        this.status = status;
        this.orderData = orderData;
    }

    @Temporal(TemporalType.DATE)
    private Date timestamp;

    private String status;

    @OneToOne
    @JoinColumn(name = "order_id")
    private OrderData orderData; // XXX could be uni-direction

    public Date getTimestamp() { return timestamp; }
    public void setTimestamp(Date timestamp) { this.timestamp = timestamp; }

    public String getStatus() { return status; }
    public void setStatus(String status) { this.status = status; }

    public OrderData getOrderData() { return orderData; }
    public void setOrderData(OrderData orderData) { this.orderData = orderData; }
}
