package my.petstore.entity;

import java.util.Collections;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name = "products")
public class Product extends NamedEntity {
    
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "category_id")
    private Category category;
    
    @Column(name = "image_path")
    private String imagePath;

    @Column(name = "descn")
    private String description;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "product", fetch = FetchType.EAGER)
    private Set<Item> items;


    public Category getCategory() { return category; }
    public void setCategory(Category category) { this.category = category; }
    public Integer getCategoryId() { return category.getId(); }

    public String getImagePath() { return imagePath; }
    public void setImagePath(String imagePath) { this.imagePath = imagePath; }

    public String getDescription() { return description; }
    public void setDescription(String description) { this.description = description; }

    public Set<Item> getItems() { return items; }
    public void setItems(Set<Item> items) { this.items = items; }
    
    @Override
    public String toString() {
        return getName() + ", " + getDescription();
    }

    public static final Product NULL = new Product() {
        {
            setCategory(Category.NULL);
            setDescription("");
            setItems(Collections.<Item>emptySet());
        }
    };
}
