package my.petstore.web;

import my.petstore.entity.OrderData;
import my.petstore.service.OrderService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class ViewOrderController {

    @Autowired
    private OrderService orderService;

    @RequestMapping(value="/orders", method=RequestMethod.GET)
    public String orders(Model model) {
        model.addAttribute("orderList", orderService.getOrderData());
        return "ListOrders";
    }

    @RequestMapping(value="/orders/{orderId}", method=RequestMethod.GET)
    public ModelAndView order(@PathVariable("orderId") int orderId) {
        OrderData orderData = orderService.getOrderData(orderId);
        return new ModelAndView("ViewOrder", "orderData", orderData);
    }
}
