package my.petstore.service;

import static org.junit.Assert.assertThat;
import static org.hamcrest.Matchers.*;

import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import my.petstore.entity.Product;
import my.petstore.entity.Item;
import my.petstore.entity.OrderData;
import my.petstore.entity.Category;

@ContextConfiguration(locations = {"classpath:spring/applicationContext-jpa.xml"})
@RunWith(SpringJUnit4ClassRunner.class)
public class ProductServiceTest {

    @Autowired
    protected ProductService productService;

    @Test
    public void getCategoryList() {
        List<Category> result = productService.getCategoryList();
        assertThat(result, notNullValue());
        assertThat(result.isEmpty(), is(false));
    }

    @Test
    public void getCategory() {
        Category result = productService.getCategory(-1);
        assertThat(result, notNullValue());
        assertThat(result, is(Category.NULL));

        result = productService.getCategory(1);
        assertThat(result, notNullValue());
        assertThat(result, is(not(Category.NULL)));
    }

}
